extern CINFO **initClientInfoHead;
extern CINFO **unInitClientInfoHead;
extern unsigned long clientListSem, initializeSem;
extern unsigned long destroySem, querySem;
extern struct IPX_ECBStruct **watchdogHead, **initializeHead;
extern struct IPX_ECBStruct **shutdownHead, **queryHead;
extern int shutdown, shutdownOK;
extern CINFO *firstUnInitClient, *firstInitClient;
extern LONG SAPHandle;
extern char serverName[48];
extern LONG debugScreenID;

#ifndef BROKER_DEFINES

#define NLM
#define BROKER_DEFINES
#define WATCHDOG_SOCKET          0x0086
#define INITIALIZE_SOCKET        0x0087
#define SHUTDOWN_SOCKET          0x0088
#define QUERY_SOCKET             0x0089

#define REQUEST_PACKET           0x0001
#define RESPONSE_PACKET          0x0002
#define TIME_REMAINING_REQUEST   0x0003
#define TIME_REMAINING_RESPONSE  0x0004
#define SPACE_REMAINING_REQUEST  0x0005
#define SPACE_REMAINING_RESPONSE 0X0006
#define SHUTDOWN_NOW             0x0003

#define ONE_MINUTE               0x1770
#define TWO_MINUTES              0x2ee0
#define FIVE_MINUTES             0x7530
#define TEN_MINUTES              0xea60
#define SVC_TYPE 0x0187

typedef struct clientInfoPacket {
   BYTE packetType;
   char userName[49];
   unsigned long spaceRequired;
   unsigned long duration;
   BYTE info[480];
}CINFOPACKET;

typedef struct serverInfoPacket {
   BYTE packetType;
   char serverName[49];
   LONG spaceAvailable;
   BYTE info[480]
}SINFOPACKET;

typedef struct shutDownPacket {
   BYTE packetType;
   time_t timeOut;
   LONG responseCode;
}SHUTDOWN;
        
typedef struct queryPacket {
   BYTE packetType;
   char name[49];
   int spaceUsed;
   time_t timeOut;
   BYTE info[480];
}QUERY;

typedef struct responsePacket {
   BYTE packetType;
   LONG responseCode;
}REQUEST_RESPOND;


typedef struct watchdog {
   BYTE status;
   unsigned long codes[4];
}WATCHDOG;


typedef struct clientInfo {
   struct clientInfo *next;
   char clientName[49];
   struct InternetAddress address;
   time_t loginTime;
   unsigned long duration;
   unsigned long spaceInUse;
   LONG objectID;
   BYTE watchdogStatus;
   BYTE shutdownStatus;
   char dirPath[256];
   char loginPath[256];
   BYTE volumeNumber;
   LONG directoriesInUse;
   LONG filesInUse;
   LONG blocksInUse;
   WATCHDOG code;
}CINFO;


typedef struct serverInfo {
   char servername[49];
   struct InternetAddress address;
   time_t duration;
   LONG spaceInUse;
   LONG spaceAvailable;
   int totalClients;
   int currentClients;
}SINFO;


typedef struct shortVolInfo {
   LONG systemElapsedTime;
   BYTE volumeNumber;
   BYTE logicalDriveNumber;
   WORD sectorsPerBlock;
   short startingBlock;
   LONG totalBlocks;
   LONG availableBlocks;
}SVOL;


typedef struct brokerCallBackStruct {
   struct AESProcessStructure *ALink;
   LONG AWakeUpDelayAmount;
   LONG AWakeUpTime;
   void (*AProcessToCall)(void *);
   LONG ARTag;
   LONG AOldLink;
   CINFO **clientHead;
}BROKER_CALL_BACK;


#endif

extern int DestroyClient(CINFO *);
extern int SetupClientInfo(CINFO *);
