#include <stdio.h>
#include <nwipxspx.h>
#include <nwsemaph.h>
#include <conio.h>
#include <process.h>
#include <time.h>
#include <nwenvrn.h>
#include <advanced.h>
#include <sap.h>
#include <nwtypes.h>


#ifndef BROKER_DEFINES

#define NLM
#define BROKER_DEFINES
#define WATCHDOG_SOCKET          0x0086
#define INITIALIZE_SOCKET        0x0087
#define SHUTDOWN_SOCKET          0x0088
#define QUERY_SOCKET             0x0089

#define REQUEST_PACKET           0x0001
#define RESPONSE_PACKET          0x0002
#define TIME_REMAINING_REQUEST   0x0003
#define TIME_REMAINING_RESPONSE  0x0004
#define SPACE_REMAINING_REQUEST  0x0005
#define SPACE_REMAINING_RESPONSE 0X0006
#define SHUTDOWN_NOW             0x0003

#define ONE_MINUTE               0x1770
#define TWO_MINUTES              0x2ee0
#define FIVE_MINUTES             0x7530
#define TEN_MINUTES              0xea60
#define SVC_TYPE 0x0187

#define NWDS_IMPORT_NAME_LIST		\
	"NWDSAddObject",					\
	"NWDSAllocBuf",					\
	"NWDSBeginClassItem",			\
	"NWDSCreateContext",				\
	"NWDSDefineClass",				\
	"NWDSFreeBuf",						\
	"NWDSFreeContext",				\
	"NWDSGenerateObjectKeyPair",	\
	"NWDSGetAttrCount",				\
	"NWDSGetAttrName",				\
	"NWDSGetAttrVal",					\
	"NWDSInitBuf",						\
	"NWDSLogin",						\
	"NWDSMapNameToID",				\
	"NWDSModifyObject",				\
	"NWDSOpenStream",					\
	"NWDSPutAttrName",				\
	"NWDSPutAttrVal",					\
	"NWDSPutChange",					\
	"NWDSPutClassItem",				\
	"NWDSRead",							\
	"NWDSRemoveObject"

struct NWDSImports {
	T_NWDSAddObject					AddObject;
	T_NWDSAllocBuf						AllocBuf;
	T_NWDSBeginClassItem				BeginClassItem;
	T_NWDSCreateContext				CreateContext;
	T_NWDSDefineClass					DefineClass;
	T_NWDSFreeBuf						FreeBuf;
	T_NWDSFreeContext					FreeContext;
	T_NWDSGenerateObjectKeyPair	GenerateObjectKeyPair;
	T_NWDSGetAttrCount				GetAttrCount;
	T_NWDSGetAttrName					GetAttrName;
	T_NWDSGetAttrVal					GetAttrVal;
	T_NWDSInitBuf						InitBuf;
	T_NWDSLogin							Login;
	T_NWDSMapNameToID					MapNameToID;
	T_NWDSModifyObject				ModifyObject;
	T_NWDSOpenStream					OpenStream;
	T_NWDSPutAttrName					PutAttrName;
	T_NWDSPutAttrVal					PutAttrVal;
	T_NWDSPutChange					PutChange;
	T_NWDSPutClassItem				PutClassItem;
	T_NWDSRead							Read;
	T_NWDSRemoveObject				RemoveObject;
};


typedef struct clientInfoPacket {
   BYTE packetType;
   char userName[49];
   int spaceRequired;
   time_t duration;
   BYTE info[480];
}CINFOPACKET;

typedef struct serverInfoPacket {
   BYTE packetType;
   char serverName[49];
   LONG spaceAvailable;
   BYTE info[480];
}SINFOPACKET;

typedef struct shutDownPacket {
   BYTE packetType;
   time_t timeOut;
   LONG responseCode;
}SHUTDOWN;
        
typedef struct queryPacket {
   BYTE packetType;
   char name[49];
   int spaceUsed;
   time_t timeOut;
   BYTE info[480];
}QUERY;

typedef struct responsePacket {
   BYTE packetType;
   LONG responseCode;
}REQUEST_RESPOND;

typedef struct watchdog {
   BYTE status;
   unsigned long codes[4];
}WATCHDOG;

typedef struct clientInfo {
   struct clientInfo *next;
   char clientName[49];
   InternetAddress address;
   time_t loginTime;
   time_t duration;
   int spaceInUse;
   LONG objectID;
   BYTE watchdogStatus;
   BYTE shutdownStatus;
   char dirPath[256];
   char loginPath[256];
   BYTE volumeNumber;
   LONG directoriesInUse;
   LONG filesInUse;
   LONG blocksInUse;
   WATCHDOG code;
}CINFO;


typedef struct serverInfo {
   char servername[49];
   InternetAddress address;
   time_t duration;
   LONG spaceInUse;
   LONG spaceAvailable;
   int totalClients;
   int currentClients;
}SINFO;


typedef struct shortVolInfo {
   LONG systemElapsedTime;
   BYTE volumeNumber;
   BYTE logicalDriveNumber;
   WORD sectorsPerBlock;
   short startingBlock;
   LONG totalBlocks;
   LONG availableBlocks;
}SVOL;


typedef struct brokerCallBackStruct {
   struct AESProcessStructure *ALink;
   LONG AWakeUpDelayAmount;
   LONG AWakeUpTime;
   void (*AProcessToCall)(void *);
   LONG ARTag;
   LONG AOldLink;
   CINFO **clientHead;
}BROKER_CALL_BACK;


#endif


extern void ShutdownCleanUp(void);
extern void ConnectMain(void *);
extern struct NWDSImports NWDS;
extern int usingNDS;



