#ifndef FMON_INCLUDES
#define FMON_INCLUDES
                                 
#define ERASE_FILE                  0x00000000
#define OPEN_FILE                   0x00000001
#define CREATE_FILE                 0x00000002
#define CREATE_AND_OPEN_FILE        0x00000003
#define RENAME_MOVE_ENTRY           0x00000004
#define CLOSE_FILE                  0x00000005
#define CREATE_DIRECTORY            0x00000006
#define DELETE_DIRECTORY            0x00000007
#define MODIFY_DIR_ENTRY            0x00000008

#define SALVAGE_DELETED_FILE        0x00000009
#define PURGE_DELETED_FILE          0x0000000a
#define RENAME_NAME_SPACE_ENTRY     0x0000000b
#define RECOVER_SALVAGEABLE_FILE    0x0000000c
#define PURGE_SALVAGEABLE_FILE      0x0000000d
#define OPEN_CREATE_FILE_OR_FOLDER  0x0000000e
#define RENAME_FILE_OR_FOLDER       0x0000000f
#define ERASE_FILE_OR_FOLDER        0x00000010
#define MODIFY_DOS_INFO             0x00000011
#define MODIFY_NAME_SPACE_INFO      0x00000012

#define FileSystemMonitorSignature	0x534d5346			/* 'SMSF' */
#define	NumberOfDirectoryTrustees	4


#define HOOK_EXIT(a) ((a) | 0x80000000)


typedef struct {
   LONG member1;
   LONG member2;
   LONG member3;
   LONG member4;
   LONG member5;
   LONG member6;
   LONG member7;
   LONG member8;
   LONG member9;
   LONG member10;
   LONG member11;
   LONG member12;
   LONG member13;
   LONG member14;
   LONG member15;
}GenericAddress;


struct	ModifyStructure
{
	BYTE *MModifyName;
	LONG MFileAttributes;
	LONG MFileAttributesMask;		/*- goes with above -*/
	WORD MCreateDate;
	WORD MCreateTime;
	LONG MOwnerID;
	WORD MLastArchivedDate;
	WORD MLastArchivedTime;
	LONG MLastArchivedID;
	WORD MLastUpdatedDate;
	WORD MLastUpdatedTime;
	LONG MLastUpdatedID;
	WORD MLastAccessedDate;
	WORD MInheritanceGrantMask;
	WORD MInheritanceRevokeMask;	/*- goes with above -*/
	int MMaximumSpace;
};

#define MModifyNameBit						0x0001
#define MFileAttributesBit					0x0002
#define MCreateDateBit						0x0004
#define MCreateTimeBit						0x0008
#define MOwnerIDBit							0x0010
#define MLastArchivedDateBit				0x0020
#define MLastArchivedTimeBit				0x0040
#define MLastArchivedIDBit					0x0080
#define MLastUpdatedDateBit				0x0100
#define MLastUpdatedTimeBit				0x0200
#define MLastUpdatedIDBit					0x0400
#define MLastAccessedDateBit				0x0800
#define MInheritanceRestrictionMaskBit	0x1000
#define MMaximumSpaceBit					0x2000

typedef struct {
   LONG hookNumber;
   LONG timeStamp;
   LONG hookData[15];
   LONG pad[15];
}MonitorNode;

#endif
