#include <nwnet.h>
#include <stdio.h>

#define FALSE 0
#define TRUE 1

#include <nwconn.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>
#include <malloc.h>


typedef void (*funcPointer)(NWDSContextHandle, char *, char *, char *);

void temp(void);

typedef struct
{ char        *name;
   funcPointer func;
}FUNCTION_INFO;

// ********************************************************
// Example code for authenticating to an additional service
// ********************************************************
void main()
{ NWDSContextHandle     nContext;
  char                  objectName[80], password[80], currentContext[MAX_DN_CHARS + 1];
  char                  fileServerName[50];
  int                   err;
  WORD                  connID;

  // Initialize Unicode Table. Necessary for workstations not NLMs.
  err = NWInitUnicodeTables(001,437);
  if(err)
    { printf("ERROR in NWInitUnicodeTables: <%d>\n", err);
      goto EndProc;
    }

  // Create context and check for errors.
  nContext  = NWDSCreateContext();
  if(nContext == ERR_CONTEXT_CREATION)
    { printf("ERROR Could not create context\n");
      goto EndProc;
    }

  // Check the context to see if you need to set it to something different.
  err = NWDSGetContext(nContext, DCK_NAME_CONTEXT, currentContext);
  if(err<0)
    { printf("ERROR %d in NWDSGetContext\n", err);
      goto EndProc;
    }
  printf("\nCurrent Context--> %s\n", currentContext);

  // Change the context if necessary.
  printf("Enter to accept current context\n"
	 "or enter the new context: ");
  gets(currentContext);
  if(currentContext != "")
    { err = NWDSSetContext(nContext, DCK_NAME_CONTEXT, currentContext);
      if(err<0)
	{ printf("ERROR %d in NWDSGetContext\n", err);
	  goto EndProc;
	}
    }


  // Login to Directory Services
  printf("Enter objectName to login as: ");
  scanf("%s",objectName);
  printf("Enter password: ");
  scanf("%s",password);
  err = NWDSLogin(nContext, 0, objectName, password, 0);
  if(err<0)
    { printf("ERROR %d in NWDSLogin\n", err);
      goto EndProc;
    }
  else 
    printf("Successful completion of call to NWDSLogin\n");

  // Attach to the fileserver
  printf("Enter the fileServerName: ");
  scanf("%s",fileServerName);
  err = AttachToFileServer(fileServerName,&connID);
  if (err<0)
    { printf("ERROR %d in attaching to fileserver.\n", err);
      goto EndProc;
    }
  else
    printf("Attach to server successful.\n");
  
  // Authenticate to the Server
  err = NWDSAuthenticate(connID, 0, 0);
  if(err<0)
    { printf("ERROR %d in NWDSAuthenticate\n", err);
      goto EndProc;
    }
  printf("Successful completion of call to NWDSAuthenticate\n");

EndProc:
  NWDSFreeContext(nContext);
#ifdef why
  NWFreeUnicodeTables();
#endif
}
