#include <ndswin.h>

#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <stdlib.h>

extern rights;

uint32  changeTypeList[] = { DS_ADD_ATTRIBUTE,
			     DS_REMOVE_ATTRIBUTE,
			     DS_ADD_VALUE,
			     DS_REMOVE_VALUE
			   };

void TestModObjectAcl
{ NWDSContextHandle   context,
  char                objectName[80];
  char                aclName[128];
  char                input[40];
  int                 err, syntaxID;
  uint32              attrCount = 0, changeType;
  Buf_T               *changes;
  size_t              bufSize;
  Object_ACL_T        ACL;
  int32               iterHandle;

  bufSize = DEFAULT_MESSAGE_LEN;
  err = NWDSAllocBuf(bufSize, &changes);
  if(err<0)
    { printf("ERROR %d in NWDSAllocBuf\n", err);
      goto EndProc;
     }

  err = NWDSInitBuf(context, DSV_MODIFY_ENTRY, changes);
  if(err<0)
    { printf("ERROR %d in NWDSAllocBuf\n", err);
      goto EndProc;
    }

  strcpy(ACL.protectedAttrName,DS_ENTRY_RIGHTS_NAME);
  if(!strcmp(aclName,"NULL"))
    strcpy(ACL.subjectName,DS_MASK_NAME);
    else
    ACL.subjectName =  aclName;
  ACL.privileges = rights;
  err = NWDSPutChange(context, changes, changeTypeList[changeType], "ACL");
  if(err<0)
    { printf("ERROR %d in NWDSPutChange\n", err);
      goto EndProc;
    }
  syntaxID = SYN_OBJECT_ACL;
  if(changeType != DS_REMOVE_ATTRIBUTE)
    { err = NWDSPutAttrVal(context, changes, (uint32)syntaxID, &ACL);
      if(err<0)
	{ printf("ERROR %d in NWDSPutAttrValue\n", err);
	  goto EndProc;
	}
    }

  err = NWDSModifyObject(context, objectName, &iterHandle, 0, changes);
  if(err<0)
    { printf("ERROR %d in NWDSModifyObject\n", err);
      goto EndProc;
    }

EndProc:
  NWDSFreeBuf(changes);
}
void TestModInheritedAcl
(
     NWDSContextHandle context,
     char *objectName,
     char *aclName
)
{    
     char      input[40];
     int       err,
                    syntaxID;
     uint32    attrCount = 0,
                    changeType;
     Buf_T          *changes;
     size_t    bufSize;
     Object_ACL_T ACL;
     int32          iterHandle;

     

     bufSize = DEFAULT_MESSAGE_LEN;

     err = NWDSAllocBuf(bufSize, &changes);

     if (err < 0)
     {
          printf("%s in NWDSAllocBuf.\n", NWDSErrorMessage(err));
          goto Cleanup0;
     }

     err = NWDSInitBuf(context, DSV_MODIFY_ENTRY, /* 1, */ changes);

     if (err < 0)
     {
          printf("%s in NWDSAllocBuf.\n", NWDSErrorMessage(err));
          goto Cleanup1;
     }

     attrCount = 1;

     printf("Possible modifications:\n");
     printf("\t1-Add attribute\n");
     printf("\t2-Remove Attribute\n");
     printf("\t3-Add values\n");
     printf("\t4-Remove values\n");

     printf("\tEnter one: ");
     gets(input);
     changeType = atoi(input);
     changeType--;
     
     strcpy(ACL.protectedAttrName,DS_ENTRY_RIGHTS_NAME);
     if (!strcmp(aclName,"NULL"))
          strcpy(ACL.subjectName,DS_MASK_NAME);
     else 
          ACL.subjectName =  aclName;

     ACL.privileges = rights;

     err = NWDSPutChange(context, changes, changeTypeList[changeType],
                                        "Inherited ACL"/* , attrCount */);

     if (err < 0)
     {
          printf("%s in NWDSPutChange.\n", NWDSErrorMessage(err));
          goto Cleanup1;
     }

     syntaxID = SYN_OBJECT_ACL;

     if (changeType != DS_REMOVE_ATTRIBUTE)
     {
          err = NWDSPutAttrVal(context, changes, (uint32)syntaxID, &ACL);

          if (err < 0)
          {
               printf("%s in NWDSPutAttrValue.\n", NWDSErrorMessage(err));
               goto Cleanup1;
          }
     }

     err = NWDSModifyObject(context, objectName, &iterHandle, 0, changes);

     if (err)
     {
          printf("Error %s in NWDSModifyObject.\n", NWDSErrorMessage(err));
          goto Cleanup1;
     }

Cleanup1:
     NWDSFreeBuf(changes);
Cleanup0:
     return;
}

